/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the WorkingTime type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WorkingTime{}

// WorkingTime struct for WorkingTime
type WorkingTime struct {
	From HourMinute `json:"from"`
	To HourMinute `json:"to"`
}

// NewWorkingTime instantiates a new WorkingTime object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWorkingTime(from HourMinute, to HourMinute) *WorkingTime {
	this := WorkingTime{}
	this.From = from
	this.To = to
	return &this
}

// NewWorkingTimeWithDefaults instantiates a new WorkingTime object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWorkingTimeWithDefaults() *WorkingTime {
	this := WorkingTime{}
	return &this
}

// GetFrom returns the From field value
func (o *WorkingTime) GetFrom() HourMinute {
	if o == nil {
		var ret HourMinute
		return ret
	}

	return o.From
}

// GetFromOk returns a tuple with the From field value
// and a boolean to check if the value has been set.
func (o *WorkingTime) GetFromOk() (*HourMinute, bool) {
	if o == nil {
		return nil, false
	}
	return &o.From, true
}

// SetFrom sets field value
func (o *WorkingTime) SetFrom(v HourMinute) {
	o.From = v
}

// GetTo returns the To field value
func (o *WorkingTime) GetTo() HourMinute {
	if o == nil {
		var ret HourMinute
		return ret
	}

	return o.To
}

// GetToOk returns a tuple with the To field value
// and a boolean to check if the value has been set.
func (o *WorkingTime) GetToOk() (*HourMinute, bool) {
	if o == nil {
		return nil, false
	}
	return &o.To, true
}

// SetTo sets field value
func (o *WorkingTime) SetTo(v HourMinute) {
	o.To = v
}

func (o WorkingTime) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WorkingTime) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["from"] = o.From
	toSerialize["to"] = o.To
	return toSerialize, nil
}

type NullableWorkingTime struct {
	value *WorkingTime
	isSet bool
}

func (v NullableWorkingTime) Get() *WorkingTime {
	return v.value
}

func (v *NullableWorkingTime) Set(val *WorkingTime) {
	v.value = val
	v.isSet = true
}

func (v NullableWorkingTime) IsSet() bool {
	return v.isSet
}

func (v *NullableWorkingTime) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWorkingTime(val *WorkingTime) *NullableWorkingTime {
	return &NullableWorkingTime{value: val, isSet: true}
}

func (v NullableWorkingTime) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWorkingTime) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


